## mingw-w64-arm-none-eabi-binutils-2.46.0-1.src.tar.zst

=== gprofng/examples/mxv-pthreads/src/Makefile ===
#
#   Copyright (C) 2021-2026 Free Software Foundation, Inc.
#
# This file is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING3.  If not see
# <http://www.gnu.org/licenses/>.

CC       = gcc
WARNINGS = -Wall -Werror=undef -Wstrict-prototypes
OPT      = -g -O
CFLAGS   = $(OPT) $(WARNINGS)
LDFLAGS  =
LIBS     = -lm -lpthread
OBJDIR   = ../objects
BINDIR   = ../bindir
EXPDIR   = ../experiments

EXE     = mxv-pthreads
OBJECTS = $(OBJDIR)/main.o $(OBJDIR)/manage_data.o $(OBJDIR)/workload.o $(OBJDIR)/mxv.o

default: $(BINDIR)/$(EXE)

$(BINDIR)/$(EXE): $(OBJECTS)
	@mkdir -p $(BINDIR)
	$(CC) -o $(BINDIR)/$(EXE) $(LDFLAGS) $(OBJECTS) $(LIBS)
	ldd $(BINDIR)/$(EXE)

$(OBJDIR)/main.o: main.c
	@mkdir -p $(OBJDIR)
	$(CC) -o $(OBJDIR)/main.o -c $(CFLAGS) main.c
$(OBJDIR)/manage_data.o: manage_data.c
	@mkdir -p $(OBJDIR)
	$(CC) -o $(OBJDIR)/manage_data.o -c $(CFLAGS) manage_data.c
$(OBJDIR)/workload.o: workload.c
	@mkdir -p $(OBJDIR)
	$(CC) -o $(OBJDIR)/workload.o -c $(CFLAGS) workload.c
$(OBJDIR)/mxv.o: mxv.c
	@mkdir -p $(OBJDIR)
	$(CC) -o $(OBJDIR)/mxv.o -c $(CFLAGS) mxv.c

$(OBJECTS): mydefs.h

.c.o:
	$(CC) -c -o $@ $(CFLAGS) $<

check:
	@echo "Running $(EXE) in $(EXPDIR)"
	@./$(EXPDIR)/$(EXE) -m 1000 -n 1500 -t 2

install: $(BINDIR)/$(EXE)
	@/bin/cp $(BINDIR)/$(EXE) $(EXPDIR)
	@echo "Installed $(EXE) in $(EXPDIR)"

clean:
	@/bin/rm -f $(BINDIR)/$(EXE)
	@/bin/rm -f $(OBJECTS)

veryclean:
	@make clean
	@/bin/rm -f $(EXPDIR)/$(EXE)

=== PKGBUILD ===
# Maintainer: Carlos Antunes <cmantunes@gmail.com>
# Maintainer: fauxpark <fauxpark@gmail.com>
# Contributed by: nanodude

_realname=binutils
_target=arm-none-eabi

pkgbase=mingw-w64-${_target}-${_realname}
pkgname=${MINGW_PACKAGE_PREFIX}-${_target}-${_realname}
pkgver=2.46.0
pkgrel=1
pkgdesc='GNU Tools for ARM Embedded Processors - Binutils (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
license=('spdx:GPL-3.0-or-later AND GPL-2.0-or-later AND LGPL-3.0-or-later AND LGPL-2.0-or-later')
url='https://www.gnu.org/software/binutils/binutils.html'
msys2_repository_url='https://sourceware.org/git/binutils-gdb'
msys2_references=(
  "cpe: cpe:/a:gnu:binutils"
)
groups=("${MINGW_PACKAGE_PREFIX}-${_target}-toolchain")
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread"
         "${MINGW_PACKAGE_PREFIX}-zstd")
makedepends=("${MINGW_PACKAGE_PREFIX}-autotools" "${MINGW_PACKAGE_PREFIX}-cc")
source=(https://ftp.gnu.org/gnu/${_realname}/${_realname}-${pkgver}.tar.xz{,.sig})
sha256sums=('d75a94f4d73e7a4086f7513e67e439e8fcdcbb726ffe63f4661744e6256b2cf2'
            'SKIP')
validpgpkeys=('3A24BC1E8FB409FA9F14371813FCEF89DD9E3C4F')

build() {
    mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

    ../${_realname}-${pkgver}/configure \
        --build=${MINGW_CHOST} \
        --prefix=${MINGW_PREFIX} \
        --target=${_target} \
        --libdir=${MINGW_PREFIX}/lib/${_target} \
        --enable-multilib \
        --enable-interwork \
        --with-gnu-as \
        --with-gnu-ld \
        --disable-nls \
        --enable-ld=default \
        --enable-gold \
        --enable-plugins \
        --enable-deterministic-archives

    make
}

package() {
    cd "${srcdir}/build-${MSYSTEM}"

    make DESTDIR="$pkgdir" install

    cd "${pkgdir}"${MINGW_PREFIX}

    for info in as bfd binutils ctf-spec gprof ld ldint sframe-spec; do
      mv share/info/${info}.info share/info/${_target}-${info}.info
    done
}
